package weaver.interfaces.seclinktel.crob;

import com.weaver.general.BaseBean;
import com.weaver.general.Util;
import weaver.conn.RecordSet;
import weaver.interfaces.schedule.BaseCronJob;
import weaver.interfaces.seclinktel.entity.po.ResourceOtherInfoPo;
import weaver.interfaces.seclinktel.util.DutyUtils;

import java.util.List;

/**
 * @Author liang.cheng
 * @Date 2024/11/4 2:18 PM
 * @Description: 1、年龄定时任务更新
 * @Version 1.0
 */
public class ResourceAgeUpdateCron extends BaseCronJob {


    @Override
    public void execute() {

        List<ResourceOtherInfoPo> hrmResource = DutyUtils.getHrmResource();

        BaseBean bb = new BaseBean();
        String scopeId = bb.getPropValue("seclinktel", "scopeid");
        String ageField = bb.getPropValue("seclinktel", "age");

        RecordSet rs = new RecordSet();

        hrmResource.forEach(e -> {

            //1.Age计算
            Integer age = DutyUtils.getAge(e.getBirthday());

            //2.插入更新
            rs.executeQuery("select count(1) as nums from cus_fielddata where " +
                    " scope = 'HrmCustomFieldByInfoType' and scopeid = "+scopeId+" and id = ?",e.getId());

            rs.next();
            int nums = Util.getIntValue(rs.getString("nums"));
            if (nums > 0) {
                //更新
                rs.executeUpdate("update cus_fielddata set "+ageField+" = ? " +
                        " where id=? and scope = 'HrmCustomFieldByInfoType' and "+scopeId+" = 1",age,e.getId());
            }else {
                //插入
                rs.executeUpdate("insert into cus_fielddata(scope,scopeid,id,"+ageField+") values(?,?,?,?)","HrmCustomFieldByInfoType",scopeId,e.getId(),age);
            }


        });


    }
}
